#include <opnet.h>
#include <ema.h>
#include <opnet_emadefs.h>
#include <opnet_constants.h>



/* array for all textlist attributes in model */
VosT_Textlist*		tl_ptr [17];

/* array for all objects in model */
EmaT_Object_Id		obj [54];



main (argc, argv)
	int	argc;
	char	*argv[];
	{
	EmaT_Model_Id			model_id;
	int					i;

	/* initialize EMA package */
	Ema_Init (EMAC_MODE_ERR_PRINT);

	/* create an empty model */
	model_id = Ema_Model_Create (MOD_PROCESS);



	/* create all objects */
	obj [0] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [1] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [2] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [3] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [4] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [5] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [6] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [7] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [8] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [9] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [10] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [11] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [12] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [13] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [14] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [15] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [16] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [17] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [18] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [19] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [20] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [21] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [22] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [23] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [24] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [25] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [26] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [27] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [28] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [29] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [30] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [31] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [32] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [33] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [34] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [35] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [36] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [37] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [38] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [39] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [40] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [41] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [42] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [43] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [44] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [45] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [46] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [47] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [48] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [49] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [50] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [51] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [52] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [53] = Ema_Object_Create (model_id, OBJ_PR_POS);


	/* set the model level attributes */
	/* create and init textlist 'tl_ptr [0]' */
	tl_ptr [0] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [0], 
		"int      				\\server_busy,\\def_net,\\def_nod;",
		"double   				\\service_rate;",
		"Objid    				\\own_id;",
		"int						\\net_num0, \\node_num0;",
		"int						\\net_num1, \\node_num1;",
		"int						\\net_num2, \\node_num2;",
		"Ici*					\\arp_iciptr;",
		"ip_dgram_list*			\\dgram_list_ptr;",
		"int						\\default_ttl;",
		"int		\\rte_tab[500];",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [1]' */
	tl_ptr [1] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [1], 
		"double          pk_svc_time;",
		"int             insert_ok,protocol;",
		"int				in_strm,outstrm, mtu, frag;",
		"int				next_net, next_node;",
		"int				dest_net, dest_node,src_net,src_node;",
		"int				i, frag_accum, num_frags;",
		"int				frag_size, data_size, len;",
		"int				header_size, ttl;",
		"Packet			*pkptr, *ip_pkptr, *frag_ptr;",
		"Packet			*data_pkptr;",
		"Packet 			*rsvp_pkptr, *tmp_pkptr;",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [2]' */
	tl_ptr [2] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [2], 
		"#include \"ip_frag_sup.h\"",
		"",
		"/* ",
		"** Macros Used to Represent Transitions. ",
		"*/",
		"#define QUEUE_EMPTY     	(op_q_empty ())",
		"#define SVC_COMPLETION  	op_intrpt_type () == OPC_INTRPT_SELF",
		"#define ARRIVAL         	op_intrpt_type () == OPC_INTRPT_STRM",
		"#define RSVP 46",
		"#define FD_GWY_ND 2",
		"",
		"/*",
		"** Protocol ID's and Versions of RSVP and OSPF protocols simulated",
		"*/",
		"#define IGMP_PROTOCOL_ID	9",
		"#define TCP_PROTOCOL_ID		12",
		"#define QOSPF_PROTOCOL_ID	89",
		"#define RSVP_PROTOCOL_ID	46",
		"#define UDP_PROTOCOL_ID		20",
		"#define RSVP_VERSION		1",
		"#define OSPF_VERSION		1",
		"",
		"",
		"/*",
		"** Streams of the model. Packets are sent on these streams ",
		"*/",
		"#define IGMP_STREAM 		0",
		"#define ARP_STREAM 			1",
		"#define DEF_STREAM			1",
		"#define RAPP_STREAM			2",
		"#define RSVP_STREAM			3",
		"#define UAPP_STREAM			4",
		"#define MAPP_STREAM			5",
		"",
		"#define VL 					if(ON)",
		"#define MCVL				if(ON)",
		"#define IDLE 				0",
		"#define BUSY				1",
		"#define OFF					0",
		"#define ON					1",
		"#define FALSE				0",
		"#define TRUE				1",
		"#define MTU                 4096",
		"#define UNDEFINED			-1",
		"#define MAX_ROU_TABLE_SIZE  5",
		"/* ",
		"** Default value for the time-to-live counter. This value is assigned when a packet is received ",
		"** which does not already have a ttl field. ",
		"*/",
		"#define IP_DEFAULT_TTL			32",
		"#define IS_MULTICAST			500",
		"",
		"ip_dgram_list* ip_frag_sup_setup();",
		"",
		"/*",
		"** IP Address structure",
		"*/",
		"typedef struct ",
		"{",
		"    int NetNum;",
		"    int NodeNum;",
		"} IPAddress;",
		VOSC_EOL);

	/* create and init textlist 'tl_ptr [4]' */
	tl_ptr [4] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [4], 
		"op_prg_odb_print_major (\"State of Reassembly Table:\", OPC_NIL);",
		"ip_frag_sup_print (dgram_list_ptr);",
		VOSC_EOL);

	Ema_Model_Attr_Set (model_id,
		"state vars",           COMP_CONTENTS, tl_ptr [0],
		"temp vars",            COMP_CONTENTS, tl_ptr [1],
		"header block",         COMP_CONTENTS, tl_ptr [2],
		"diag block",           COMP_CONTENTS, tl_ptr [4],
		EMAC_EOL);


	/* create model level attribute extensions */
	Ema_Model_Attr_Add (model_id, "service_rate", EMAC_DOUBLE, "pkts/sec", (double) 1);
	Ema_Model_Attr_Add (model_id, "route_file", EMAC_DATAFILE, "", "none");
	Ema_Model_Attr_Add (model_id, "net_num0", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "node_num0", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "net_num1", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "node_num1", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "net_num2", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Add (model_id, "node_num2", EMAC_INTEGER, "", 0);
	Ema_Model_Attr_Set (model_id,
		"service_rate",         COMP_PROMOTE, EMAC_DISABLED,
		"route_file",           COMP_PROMOTE, EMAC_DISABLED,
		"net_num0",             COMP_PROMOTE, EMAC_DISABLED,
		"node_num0",            COMP_PROMOTE, EMAC_DISABLED,
		"net_num1",             COMP_PROMOTE, EMAC_DISABLED,
		"node_num1",            COMP_PROMOTE, EMAC_DISABLED,
		"net_num2",             COMP_PROMOTE, EMAC_DISABLED,
		"node_num2",            COMP_PROMOTE, EMAC_DISABLED,
		EMAC_EOL);



	/* assign attrs for object 'obj [0]' */
	/* create and init textlist 'tl_ptr [7]' */
	tl_ptr [7] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [7], 
		"/****************************************************************************************************",
		"** Process Model : ip_host_rte                                                                     **",
		"** State         : init                                                                            **",
		"** Authors       : Ravi Malghan(rmalghan@descartes.gmu.edu) & Lava K Lavu(llavu@nac.gmu.edu)       **",
		"**                                                                                                 **",
		"** This state intializes all the variables that are used in the module, create an datagram list to **",
		"** hold the fragments, get all the attributes from the configuration file                          **",
		"**                                                                                                 **",
		"****************************************************************************************************/",
		"",
		"server_busy = IDLE;        /* Intialize the server to be idle */",
		"",
		"/* ",
		"** Get the object id of this module and load all the attributes from the configuration file",
		"*/",
		"own_id = op_id_self ();",
		"op_ima_obj_attr_get (own_id, \"service_rate\", &service_rate);   /*     Service rate attribute       */",
		"op_ima_obj_attr_get (own_id, \"net_num0\", &net_num0);           /*     Following 6 lines are the    */",
		"op_ima_obj_attr_get (own_id, \"net_num1\", &net_num1);		   /*   Network Addresses of Various   */",
		"op_ima_obj_attr_get (own_id, \"net_num2\", &net_num2);           /*            interfaces            */",
		"op_ima_obj_attr_get (own_id, \"node_num0\", &node_num0);",
		"op_ima_obj_attr_get (own_id, \"node_num1\", &node_num1);",
		"op_ima_obj_attr_get (own_id, \"node_num2\", &node_num2);",
		"",
		"/* ",
		"** Create a datagram list to hold datagram fragments until the complete datagram can be ",
		"** reconstructed from the fragments. ",
		"*/",
		"dgram_list_ptr = ip_frag_sup_setup ();",
		"",
		"arp_iciptr = op_ici_create(\"ip_arp_req\");      /* ICI to communicate the destination address to arp */",
		"",
		"for( i = 0; i < MAX_ROU_TABLE_SIZE; i++ )",
		"	rte_tab[i] = 0;            /* Intialize the routing table intially to have no predefined routes */",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [0], 
		"name",                 COMP_CONTENTS, "init",
		"enter execs",          COMP_CONTENTS, tl_ptr [7],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [1],
		"initial",              COMP_TOGGLE,   EMAC_ENABLED,
		EMAC_EOL);


	/* assign attrs for object 'obj [1]' */
	Ema_Object_Attr_Set (model_id, obj [1], 
		"x",                    COMP_CONTENTS, (double) 150,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [2]' */
	/* create and init textlist 'tl_ptr [9]' */
	tl_ptr [9] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [9], 
		"/**********************************************************************************************************",
		"** Process Model : ip_host_rte                                                                           **",
		"** State         : arrival                                                                               **",
		"**                                                                                                       **",
		"** The transition to  this state occurs when there is packet arrival to this module  form any of one its **",
		"** streams. This state checks for the ttl field and if it is not set then sets that field to the default **",
		"** ttl value(32). It enqueues the packet into a subqueue for service                                     **",
		"**                                                                                                       **",
		"**********************************************************************************************************/",
		"",
		"/* ",
		"** acquire the arriving packet. Multiple arriving streams are supported. ",
		"*/",
		"in_strm = op_intrpt_strm ();",
		"pkptr = op_pk_get (in_strm);",
		"op_pk_nfd_set(pkptr,\"strm\",in_strm);",
		"",
		"/* ",
		"** If the received packet does not yet have a time-to-live field assignment, place the default value in ",
		"** this  field. In this  model, ttl is  treated as a  hop allowance  decremented  by one prior  to each ",
		"** transmission. If the decremented counter reaches zero, the packet is not transmitted. ",
		"*/",
		"if( !op_pk_nfd_is_set (pkptr, \"ttl\") )",
		"{",
		"    op_pk_nfd_set (pkptr, \"ttl\", IP_DEFAULT_TTL);",
		"}",
		"",
		"/* ",
		"** attempt to enqueue the packet at tail of subqueue 0 ",
		"*/",
		"if (op_subq_pk_insert (0, pkptr, OPC_QPOS_TAIL) != OPC_QINS_OK)",
		"{",
		"	/* ",
		"	** If insertion fails(due to a full queue), deallocate the packet set flag indicating that insertion ",
		"	** failed. This flag is used to determine the transition from this state  */",
		"",
		"    op_pk_destroy(pkptr);           ",
		"    insert_ok = FALSE;		            ",
		"}",
		"else",
		"{",
		"    insert_ok = TRUE;",
		"}",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [2], 
		"name",                 COMP_CONTENTS, "arrival",
		"enter execs",          COMP_CONTENTS, tl_ptr [9],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [3],
		EMAC_EOL);


	/* assign attrs for object 'obj [3]' */
	Ema_Object_Attr_Set (model_id, obj [3], 
		"x",                    COMP_CONTENTS, (double) 270,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [4]' */
	Ema_Object_Attr_Set (model_id, obj [4], 
		"name",                 COMP_CONTENTS, "idle",
		"position",             COMP_CONTENTS, obj [5],
		EMAC_EOL);


	/* assign attrs for object 'obj [5]' */
	Ema_Object_Attr_Set (model_id, obj [5], 
		"x",                    COMP_CONTENTS, (double) 330,
		"y",                    COMP_CONTENTS, (double) 270,
		EMAC_EOL);


	/* assign attrs for object 'obj [6]' */
	/* create and init textlist 'tl_ptr [13]' */
	tl_ptr [13] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [13], 
		"/**********************************************************************************************************",
		"** Process Model : ip_host_rte                                                                           **",
		"** State         : svc_start                                                                             **",
		"**                                                                                                       **",
		"** Transition to this state is from the arrival state and the transition condition is a packet should be **",
		"** inserted into the sub queue. This state on default transits to the idle state.                        **",
		"**                                                                                                       **",
		"**********************************************************************************************************/",
		"",
		"pk_svc_time = 1.0/service_rate;    /* Time required to service each packet */",
		"/* ",
		"** schedule an interrupt for this process at the time where service ends. ",
		"*/",
		"op_intrpt_schedule_self (op_sim_time () + pk_svc_time, 0);",
		"server_busy = BUSY;",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [6], 
		"name",                 COMP_CONTENTS, "svc_start",
		"enter execs",          COMP_CONTENTS, tl_ptr [13],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [7],
		EMAC_EOL);


	/* assign attrs for object 'obj [7]' */
	Ema_Object_Attr_Set (model_id, obj [7], 
		"x",                    COMP_CONTENTS, (double) 390,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [8]' */
	/* create and init textlist 'tl_ptr [15]' */
	tl_ptr [15] = Vos_Textlist_Create ();
	Vos_Textlist_Append (tl_ptr [15], 
		"/******************************************************************************************************",
		"** Process Module : ip_host_rte                                                                      **",
		"** State          : svc_compl                                                                        **",
		"**                                                                                                   **",
		"** This state gets the packet from the queue. If  the packets have reached their destination then it **",
		"** reassembles the packet before sending it to the application layer. If it hasn't reached the final **",
		"** destination it sends that packet to next hop. It also performs fragmentation of the packet if the **",
		"** data length is more than mtu(maximum transmission unit) This state on transits to svc_stat if the **",
		"** queue is not empty. It transits to idle state on default(if queue is empty)                       **",
		"**                                                                                                   **",
		"******************************************************************************************************/",
		"",
		"/* ",
		"** extract packet at head of queue this is the packet just finishing service ",
		"*/",
		"pkptr = op_subq_pk_remove (0, OPC_QPOS_HEAD);",
		"",
		"/* ",
		"** An IP packet has completed service. Obtain the destination network and node numbers. ",
		"*/",
		"op_pk_nfd_get (pkptr, \"dest_node\", &dest_node);",
		"op_pk_nfd_get (pkptr, \"dest_net\", &dest_net);",
		"op_pk_nfd_get (pkptr, \"src_net\", &src_net);",
		"op_pk_nfd_get (pkptr, \"src_node\", &src_node);",
		"op_pk_nfd_get (pkptr, \"strm\", &in_strm);",
		"op_pk_nfd_get (pkptr, \"prot_id\", &protocol);",
		"",
		"/*",
		"** If the packet is not destinated to this host and if the packet is not a multicast packet and ",
		"** if there is no  route to the destination in  this host's routing table then drop  the packet ",
		"*/",
		"if((dest_net != net_num0 && dest_node != node_num0) && dest_net != IS_MULTICAST && ",
		"	rte_tab[dest_net] == UNDEFINED)",
		"{ ",
		"	op_pk_destroy(pkptr);",
		"	printf(\"Destroying pk b'cos no route at %d.%d\\n\",net_num0,node_num0);",
		"}",
		"else",
		"{",
		"",
		"	/* ",
		"	** If the packets have reached their destination, reassembly of ip fragments is done. ",
		"	*/",
		"	if( (dest_net == net_num0 && dest_node == node_num0) ||",
		"		(dest_net == net_num1 && dest_node == node_num1) ||",
		"		(dest_net == net_num2 && dest_node == node_num2) ||",
		"		(dest_net == IS_MULTICAST && !( in_strm == IGMP_STREAM || in_strm == MAPP_STREAM ||",
		"		 in_strm == RSVP_STREAM || in_strm == RAPP_STREAM )) )",
		"	{",
		"		/*",
		"		**  Call the fragment reassembly procedure to determine if a complete packet has arrived. ",
		"		**  Note that the packet will be destroyed in this procedure call unless it is itself the ",
		"		**  complete datagram (i.e., it isn't a fragment) ",
		"		*/",
		"		if( (ip_pkptr = ip_frag_sup_insert (dgram_list_ptr, pkptr)) != OPC_NIL )",
		"		{",
		"			if(protocol == IGMP_PROTOCOL_ID) ",
		"				outstrm = IGMP_STREAM;",
		"			if(protocol == UDP_PROTOCOL_ID) ",
		"				outstrm = UAPP_STREAM;",
		"			if(protocol == RSVP_PROTOCOL_ID) ",
		"				outstrm =RSVP_STREAM;",
		"",
		"			if(src_net != net_num0 || src_node != node_num0)",
		"				op_pk_send (ip_pkptr, outstrm);         /* Send the packet to the higher layer. */",
		"			else ",
		"				op_pk_destroy(ip_pkptr);",
		"		}",
		"	}",
		"	/* ",
		"	** For packets which have not reached their final destination, they are send to their next hop. ",
		"	*/",
		"	else",
		"	{ ",
		"		outstrm = DEF_STREAM;",
		"		mtu = MTU;",
		"",
		"		/* ",
		"		** Decrement the packet's time-to-live field. If zero is reached, discard the packet rather ",
		"		** than send it on. ",
		"		*/",
		"		if(dest_net == IS_MULTICAST) ",
		"			next_node = dest_net +dest_node;",
		"		else ",
		"		{",
		"			if(dest_net == net_num0) ",
		"				next_node = dest_node;",
		"			else next_node = FD_GWY_ND;",
		"		}",
		"		op_pk_nfd_get (pkptr, \"ttl\", &ttl);",
		"",
		"		if( dest_net == IS_MULTICAST )",
		"			ttl--;",
		"		if( ttl == 0 )",
		"		{",
		"			",
		"			op_pk_destroy (pkptr);               /* Destroy the packet due to an expired ttl.       */",
		"		}",
		"		else",
		"		{",
		VOSC_EOL);

	Vos_Textlist_Append (tl_ptr [15], 
		"			op_pk_nfd_set (pkptr, \"ttl\", ttl);   /* Assign the new decremented value of ttl.        */",
		"",
		"",
		"			/* ",
		"			** Install an Ici indicating to the lower layer what the address of the next (intermediate) ",
		"			** node is. ",
		"			*/",
		"			op_ici_attr_set (arp_iciptr, \"next_node\", next_node);",
		"			op_ici_install (arp_iciptr);",
		"",
		"			frag_size = op_pk_total_size_get(pkptr)/8;	 /* Obtain the size of fragment in bytes     */",
		"			op_pk_nfd_get(pkptr, \"frag_len\", &data_size);/* Number of bytes of data in this fragment */",
		"",
		"			header_size = frag_size - data_size;         /* Size of Header                           */",
		"			/* ",
		"			** If the fragment is smaller than the maximum transfer unit, send it as is. ",
		"			*/",
		"			if (frag_size <= mtu)",
		"			{",
		"				op_pk_send (pkptr, outstrm);",
		"			}",
		"			else",
		"			{			",
		"				/* ",
		"				** Otherwise, break it into fragments. Each fragment can contain up to ",
		"				** (mtu - header_size) bytes of data ",
		"				*/",
		"				num_frags = (data_size + mtu - header_size - 1) / (mtu - header_size);",
		"",
		"",
		"				/* ",
		"				** If  the fragment is carrying the original datagram  given to IP, extract it ",
		"				** before copies are made. Only one fragment can carry the original packet for ",
		"				** the reassembly model to work properly. ",
		"				*/",
		"				if( op_pk_nfd_is_set( pkptr, \"ip_dgram\" ) )",
		"				op_pk_nfd_get( pkptr, \"ip_dgram\", &ip_pkptr );",
		"				else ip_pkptr = OPC_NIL;",
		"",
		"				/* ",
		"				** If the packet is carrying any encapsulated data (normally this would happen ",
		"				** only  for a packet fragmented for the first time), extract this data packet ",
		"				** so that it will not appear in each fragment generated by copying. ",
		"				*/",
		"				if( op_pk_nfd_is_set( pkptr, \"data\" ) )",
		"				op_pk_nfd_get( pkptr, \"data\", &data_pkptr );",
		"				else data_pkptr = OPC_NIL;",
		"",
		"				for (frag_accum = 0, i = 0; i < num_frags; i++)  /* Create the fragments.         */",
		"				{",
		"					frag_ptr = op_pk_copy (pkptr);        /* Make a copy of the original packet.  */",
		"					op_pk_nfd_set (frag_ptr, \"frag\", 1);  /* Indicate that the copy is a fragment */",
		"",
		"					/* ",
		"					** for all but the last fragment, the size is the mtu and the encapsulated ip ",
		"					** packet is not included. ",
		"					*/",
		"					if (i < num_frags - 1)",
		"					{",
		"						op_pk_nfd_set (frag_ptr, \"frag_len\", mtu - header_size);",
		"						op_pk_total_size_set (frag_ptr, 8 * mtu);",
		"						frag_accum += (mtu - header_size);  ",
		"					}",
		"					else",
		"					{",
		"						len = data_size - frag_accum;",
		"						op_pk_nfd_set( frag_ptr, \"frag_len\", len );",
		"						op_pk_total_size_set( frag_ptr,	8*(header_size + len) );",
		"",
		"						/* ",
		"						** If the original packet was not a fragment, encapsulate it into the last ",
		"						** fragment created here. ",
		"						*/",
		"						op_pk_nfd_get( pkptr, \"frag\", &frag );",
		"						if( !frag )",
		"						{",
		"							/* ",
		"							** If the packet  contained encapsulated data (i.e., from the transport), ",
		"							** that  data would  have been removed to  avoid its duplication  in the ",
		"							** fragments. The data should now be reinserted into the original packet. ",
		"							*/",
		"							if( data_pkptr != OPC_NIL )",
		"								op_pk_nfd_set( pkptr, \"data\", data_pkptr );",
		"",
		"							/* In either case the original packet is encapsulated in the fragment. */",
		"							op_pk_nfd_set( frag_ptr, \"ip_dgram\", pkptr );",
		"						}",
		"						else /* Otherwise the packet can be discarded. */",
		"						{",
		"							op_pk_destroy (pkptr);",
		"",
		"							/* ",
		"							** Also, if the packet includes the  original  datagram from which it was ",
		"							** generated, transfer that datagram into the last fragment created here. ",
		"							** Note that it is possible, in the case where a fragment is itself being ",
		"							** fragmented, none of  the  created fragments  will contain the original ",
		"							** datagram. ",
		"							*/",
		"							if (ip_pkptr != OPC_NIL)",
		"							{",
		VOSC_EOL);

	Vos_Textlist_Append (tl_ptr [15], 
		"								op_pk_nfd_set (frag_ptr, \"ip_dgram\", ip_pkptr);",
		"							}",
		"						}",
		"					}",
		"					op_pk_send (frag_ptr, outstrm);          /* Forward the datagram fragment.      */",
		"				}	",
		"			}",
		"		}",
		"	}",
		"}",
		"",
		"",
		"server_busy = IDLE;                 /*        The IP routing server becomes available again.        */",
		VOSC_EOL);

	Ema_Object_Attr_Set (model_id, obj [8], 
		"name",                 COMP_CONTENTS, "svc_compl",
		"enter execs",          COMP_CONTENTS, tl_ptr [15],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [9],
		EMAC_EOL);


	/* assign attrs for object 'obj [9]' */
	Ema_Object_Attr_Set (model_id, obj [9], 
		"x",                    COMP_CONTENTS, (double) 510,
		"y",                    COMP_CONTENTS, (double) 150,
		EMAC_EOL);


	/* assign attrs for object 'obj [10]' */
	Ema_Object_Attr_Set (model_id, obj [10], 
		"condition",            COMP_CONTENTS, "ARRIVAL",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [0],
		"drawing style",        COMP_TOGGLE,   EMAC_DISABLED,
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [11],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [12],
		"label pos",            COMP_CONTENTS, obj [13],
		EMAC_EOL);


	/* assign attrs for object 'obj [11]' */
	Ema_Object_Attr_Set (model_id, obj [11], 
		"x",                    COMP_CONTENTS, (double) 179,
		"y",                    COMP_CONTENTS, (double) 151,
		EMAC_EOL);


	/* assign attrs for object 'obj [12]' */
	Ema_Object_Attr_Set (model_id, obj [12], 
		"x",                    COMP_CONTENTS, (double) 240,
		"y",                    COMP_CONTENTS, (double) 151,
		EMAC_EOL);


	/* assign attrs for object 'obj [13]' */
	Ema_Object_Attr_Set (model_id, obj [13], 
		"x",                    COMP_CONTENTS, (double) 210,
		"y",                    COMP_CONTENTS, (double) 139,
		EMAC_EOL);


	/* assign attrs for object 'obj [14]' */
	Ema_Object_Attr_Set (model_id, obj [14], 
		"condition",            COMP_CONTENTS, "default",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [0],
		"path",                 COMP_ARRAY_CONTENTS (0), obj [15],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [16],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [17],
		"path",                 COMP_ARRAY_CONTENTS (3), obj [18],
		"label pos",            COMP_CONTENTS, obj [19],
		EMAC_EOL);


	/* assign attrs for object 'obj [15]' */
	Ema_Object_Attr_Set (model_id, obj [15], 
		"x",                    COMP_CONTENTS, (double) 143,
		"y",                    COMP_CONTENTS, (double) 179,
		EMAC_EOL);


	/* assign attrs for object 'obj [16]' */
	Ema_Object_Attr_Set (model_id, obj [16], 
		"x",                    COMP_CONTENTS, (double) 166,
		"y",                    COMP_CONTENTS, (double) 264,
		EMAC_EOL);


	/* assign attrs for object 'obj [17]' */
	Ema_Object_Attr_Set (model_id, obj [17], 
		"x",                    COMP_CONTENTS, (double) 235,
		"y",                    COMP_CONTENTS, (double) 278,
		EMAC_EOL);


	/* assign attrs for object 'obj [18]' */
	Ema_Object_Attr_Set (model_id, obj [18], 
		"x",                    COMP_CONTENTS, (double) 301,
		"y",                    COMP_CONTENTS, (double) 278,
		EMAC_EOL);


	/* assign attrs for object 'obj [19]' */
	Ema_Object_Attr_Set (model_id, obj [19], 
		"x",                    COMP_CONTENTS, (double) 204,
		"y",                    COMP_CONTENTS, (double) 264,
		EMAC_EOL);


	/* assign attrs for object 'obj [20]' */
	Ema_Object_Attr_Set (model_id, obj [20], 
		"condition",            COMP_CONTENTS, "!server_busy && insert_ok",
		"dest state",           COMP_CONTENTS, obj [6],
		"src state",            COMP_CONTENTS, obj [2],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [21],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [22],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [23],
		"label pos",            COMP_CONTENTS, obj [24],
		EMAC_EOL);


	/* assign attrs for object 'obj [21]' */
	Ema_Object_Attr_Set (model_id, obj [21], 
		"x",                    COMP_CONTENTS, (double) 291,
		"y",                    COMP_CONTENTS, (double) 129,
		EMAC_EOL);


	/* assign attrs for object 'obj [22]' */
	Ema_Object_Attr_Set (model_id, obj [22], 
		"x",                    COMP_CONTENTS, (double) 328,
		"y",                    COMP_CONTENTS, (double) 113,
		EMAC_EOL);


	/* assign attrs for object 'obj [23]' */
	Ema_Object_Attr_Set (model_id, obj [23], 
		"x",                    COMP_CONTENTS, (double) 370,
		"y",                    COMP_CONTENTS, (double) 127,
		EMAC_EOL);


	/* assign attrs for object 'obj [24]' */
	Ema_Object_Attr_Set (model_id, obj [24], 
		"x",                    COMP_CONTENTS, (double) 290,
		"y",                    COMP_CONTENTS, (double) 113,
		EMAC_EOL);


	/* assign attrs for object 'obj [25]' */
	Ema_Object_Attr_Set (model_id, obj [25], 
		"condition",            COMP_CONTENTS, "default",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [2],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [26],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [27],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [28],
		"label pos",            COMP_CONTENTS, obj [29],
		EMAC_EOL);


	/* assign attrs for object 'obj [26]' */
	Ema_Object_Attr_Set (model_id, obj [26], 
		"x",                    COMP_CONTENTS, (double) 266,
		"y",                    COMP_CONTENTS, (double) 179,
		EMAC_EOL);


	/* assign attrs for object 'obj [27]' */
	Ema_Object_Attr_Set (model_id, obj [27], 
		"x",                    COMP_CONTENTS, (double) 276,
		"y",                    COMP_CONTENTS, (double) 219,
		EMAC_EOL);


	/* assign attrs for object 'obj [28]' */
	Ema_Object_Attr_Set (model_id, obj [28], 
		"x",                    COMP_CONTENTS, (double) 309,
		"y",                    COMP_CONTENTS, (double) 248,
		EMAC_EOL);


	/* assign attrs for object 'obj [29]' */
	Ema_Object_Attr_Set (model_id, obj [29], 
		"x",                    COMP_CONTENTS, (double) 301,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);


	/* assign attrs for object 'obj [30]' */
	Ema_Object_Attr_Set (model_id, obj [30], 
		"condition",            COMP_CONTENTS, "ARRIVAL",
		"dest state",           COMP_CONTENTS, obj [2],
		"src state",            COMP_CONTENTS, obj [4],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [31],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [32],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [33],
		"label pos",            COMP_CONTENTS, obj [34],
		EMAC_EOL);


	/* assign attrs for object 'obj [31]' */
	Ema_Object_Attr_Set (model_id, obj [31], 
		"x",                    COMP_CONTENTS, (double) 300,
		"y",                    COMP_CONTENTS, (double) 267,
		EMAC_EOL);


	/* assign attrs for object 'obj [32]' */
	Ema_Object_Attr_Set (model_id, obj [32], 
		"x",                    COMP_CONTENTS, (double) 255,
		"y",                    COMP_CONTENTS, (double) 227,
		EMAC_EOL);


	/* assign attrs for object 'obj [33]' */
	Ema_Object_Attr_Set (model_id, obj [33], 
		"x",                    COMP_CONTENTS, (double) 256,
		"y",                    COMP_CONTENTS, (double) 176,
		EMAC_EOL);


	/* assign attrs for object 'obj [34]' */
	Ema_Object_Attr_Set (model_id, obj [34], 
		"x",                    COMP_CONTENTS, (double) 239,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);


	/* assign attrs for object 'obj [35]' */
	Ema_Object_Attr_Set (model_id, obj [35], 
		"condition",            COMP_CONTENTS, "SVC_COMPLETION",
		"dest state",           COMP_CONTENTS, obj [8],
		"src state",            COMP_CONTENTS, obj [4],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [36],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [37],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [38],
		"label pos",            COMP_CONTENTS, obj [39],
		EMAC_EOL);


	/* assign attrs for object 'obj [36]' */
	Ema_Object_Attr_Set (model_id, obj [36], 
		"x",                    COMP_CONTENTS, (double) 356,
		"y",                    COMP_CONTENTS, (double) 284,
		EMAC_EOL);


	/* assign attrs for object 'obj [37]' */
	Ema_Object_Attr_Set (model_id, obj [37], 
		"x",                    COMP_CONTENTS, (double) 480,
		"y",                    COMP_CONTENTS, (double) 234,
		EMAC_EOL);


	/* assign attrs for object 'obj [38]' */
	Ema_Object_Attr_Set (model_id, obj [38], 
		"x",                    COMP_CONTENTS, (double) 519,
		"y",                    COMP_CONTENTS, (double) 178,
		EMAC_EOL);


	/* assign attrs for object 'obj [39]' */
	Ema_Object_Attr_Set (model_id, obj [39], 
		"x",                    COMP_CONTENTS, (double) 502,
		"y",                    COMP_CONTENTS, (double) 251,
		EMAC_EOL);


	/* assign attrs for object 'obj [40]' */
	Ema_Object_Attr_Set (model_id, obj [40], 
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [6],
		"drawing style",        COMP_TOGGLE,   EMAC_DISABLED,
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [41],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [42],
		"label pos",            COMP_CONTENTS, obj [43],
		EMAC_EOL);


	/* assign attrs for object 'obj [41]' */
	Ema_Object_Attr_Set (model_id, obj [41], 
		"x",                    COMP_CONTENTS, (double) 377,
		"y",                    COMP_CONTENTS, (double) 177,
		EMAC_EOL);


	/* assign attrs for object 'obj [42]' */
	Ema_Object_Attr_Set (model_id, obj [42], 
		"x",                    COMP_CONTENTS, (double) 335,
		"y",                    COMP_CONTENTS, (double) 240,
		EMAC_EOL);


	/* assign attrs for object 'obj [43]' */
	Ema_Object_Attr_Set (model_id, obj [43], 
		"x",                    COMP_CONTENTS, (double) 361,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);


	/* assign attrs for object 'obj [44]' */
	Ema_Object_Attr_Set (model_id, obj [44], 
		"condition",            COMP_CONTENTS, "!QUEUE_EMPTY",
		"dest state",           COMP_CONTENTS, obj [6],
		"src state",            COMP_CONTENTS, obj [8],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [45],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [46],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [47],
		"label pos",            COMP_CONTENTS, obj [48],
		EMAC_EOL);


	/* assign attrs for object 'obj [45]' */
	Ema_Object_Attr_Set (model_id, obj [45], 
		"x",                    COMP_CONTENTS, (double) 489,
		"y",                    COMP_CONTENTS, (double) 127,
		EMAC_EOL);


	/* assign attrs for object 'obj [46]' */
	Ema_Object_Attr_Set (model_id, obj [46], 
		"x",                    COMP_CONTENTS, (double) 441,
		"y",                    COMP_CONTENTS, (double) 114,
		EMAC_EOL);


	/* assign attrs for object 'obj [47]' */
	Ema_Object_Attr_Set (model_id, obj [47], 
		"x",                    COMP_CONTENTS, (double) 405,
		"y",                    COMP_CONTENTS, (double) 124,
		EMAC_EOL);


	/* assign attrs for object 'obj [48]' */
	Ema_Object_Attr_Set (model_id, obj [48], 
		"x",                    COMP_CONTENTS, (double) 496,
		"y",                    COMP_CONTENTS, (double) 109,
		EMAC_EOL);


	/* assign attrs for object 'obj [49]' */
	Ema_Object_Attr_Set (model_id, obj [49], 
		"condition",            COMP_CONTENTS, "default",
		"dest state",           COMP_CONTENTS, obj [4],
		"src state",            COMP_CONTENTS, obj [8],
		"color",                COMP_CONTENTS, 48,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [50],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [51],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [52],
		"label pos",            COMP_CONTENTS, obj [53],
		EMAC_EOL);


	/* assign attrs for object 'obj [50]' */
	Ema_Object_Attr_Set (model_id, obj [50], 
		"x",                    COMP_CONTENTS, (double) 486,
		"y",                    COMP_CONTENTS, (double) 169,
		EMAC_EOL);


	/* assign attrs for object 'obj [51]' */
	Ema_Object_Attr_Set (model_id, obj [51], 
		"x",                    COMP_CONTENTS, (double) 453,
		"y",                    COMP_CONTENTS, (double) 213,
		EMAC_EOL);


	/* assign attrs for object 'obj [52]' */
	Ema_Object_Attr_Set (model_id, obj [52], 
		"x",                    COMP_CONTENTS, (double) 355,
		"y",                    COMP_CONTENTS, (double) 253,
		EMAC_EOL);


	/* assign attrs for object 'obj [53]' */
	Ema_Object_Attr_Set (model_id, obj [53], 
		"x",                    COMP_CONTENTS, (double) 434,
		"y",                    COMP_CONTENTS, (double) 206,
		EMAC_EOL);








	/* write the model to application-readable form */
	Ema_Model_Write (model_id, "ip_host_rte");

	}

